ghc-7.0.3: The GHC API

StackPlacements

Synopsis

- data SlotSet
- allStackSlots :: SlotSet
- data SlotClass
  - = SlotClass32
  - | SlotClass64
  - | SlotClass128
- slotClassBits :: SlotClass -> Int
- stackSlot32 :: SlotClass
- stackSlot64 :: SlotClass
- stackSlot128 :: SlotClass
- allSlotClasses :: [SlotClass]
- getStackSlot :: SlotClass -> SlotSet -> (StackPlacement, SlotSet)
- extendSlotSet :: SlotSet -> StackPlacement -> SlotSet
- deleteFromSlotSet :: StackPlacement -> SlotSet -> SlotSet
- elemSlotSet :: StackPlacement -> SlotSet -> Bool
- chooseSlot :: SlotClass -> [StackPlacement] -> SlotSet -> Maybe (StackPlacement, SlotSet)
- data StackPlacement
  - = FullSlot SlotClass Int
  - | YoungHalf StackPlacement
  - | OldHalf StackPlacement

# Documentation

data SlotSet

Instances

Outputable SlotSet |

allStackSlots :: SlotSet

data SlotClass

Constructors

SlotClass32 |
SlotClass64 |
SlotClass128 |

Instances

Eq SlotClass |
Outputable SlotClass |
Uniquable SlotClass |

slotClassBits :: SlotClass -> Int

stackSlot32 :: SlotClass

stackSlot64 :: SlotClass

Only supported slot classes

stackSlot128 :: SlotClass

allSlotClasses :: [SlotClass]

getStackSlot :: SlotClass -> SlotSet -> (StackPlacement, SlotSet)

extendSlotSet :: SlotSet -> StackPlacement -> SlotSet

deleteFromSlotSet :: StackPlacement -> SlotSet -> SlotSet

elemSlotSet :: StackPlacement -> SlotSet -> Bool

chooseSlot :: SlotClass -> [StackPlacement] -> SlotSet -> Maybe (StackPlacement, SlotSet)

data StackPlacement

Constructors

FullSlot SlotClass Int |
YoungHalf StackPlacement |
OldHalf StackPlacement |

Instances

Eq StackPlacement |
Outputable StackPlacement |